import React, { useState, useRef, useCallback, useEffect } from 'react';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".carousel-container {\n    --primary-color: #007bff;\n    --secondary-color: #6c757d;\n    --background-color: #000;\n    --text-color: #fff;\n    \n    position: relative;\n    width: 100%;\n    overflow: hidden;\n}\n\n/* ... existing styles ... */\n\n/* Effect styles */\n.effect-fade .carousel-slide {\n    opacity: 0;\n    transform: none;\n    transition: opacity 0.7s ease-in-out;\n}\n\n.effect-zoom .carousel-slide {\n    opacity: 0;\n    transform: scale(0.8);\n    transition: all 0.7s ease-in-out;\n}\n\n/* Ok kontrolleri */\n.carousel-arrow {\n    position: absolute;\n    top: 50%;\n    transform: translateY(-50%);\n    background: rgba(0, 0, 0, 0.5);\n    color: var(--text-color);\n    border: none;\n    padding: 15px;\n    cursor: pointer;\n    font-size: 24px;\n    z-index: 10;\n    transition: background 0.3s;\n}\n\n.carousel-arrow:hover {\n    background: rgba(0, 0, 0, 0.8);\n}\n\n.carousel-arrow.prev {\n    left: 10px;\n}\n\n.carousel-arrow.next {\n    right: 10px;\n}\n\n.carousel-arrow:disabled {\n    opacity: 0.5;\n    cursor: not-allowed;\n}\n\n/* Caption styles */\n.carousel-caption {\n    position: absolute;\n    bottom: 0;\n    left: 0;\n    right: 0;\n    padding: 20px;\n    background: rgba(0, 0, 0, 0.7);\n    color: var(--text-color);\n}\n\n.carousel-caption h3 {\n    margin: 0 0 10px;\n    font-size: 1.5em;\n}\n\n.carousel-caption p {\n    margin: 0;\n    font-size: 1em;\n}\n\n/* Thumbnail stilleri */\n.carousel-thumbnails {\n    display: flex;\n    padding: 10px;\n    background: var(--background-color);\n    gap: 10px;\n}\n\n.thumbnail-left .carousel-thumbnails {\n    position: absolute;\n    left: 0;\n    top: 0;\n    bottom: 0;\n    flex-direction: column;\n    width: 100px;\n}\n\n.thumbnail-right .carousel-thumbnails {\n    position: absolute;\n    right: 0;\n    top: 0;\n    bottom: 0;\n    flex-direction: column;\n    width: 100px;\n}\n\n.carousel-thumbnail {\n    flex: 0 0 80px;\n    height: 60px;\n    cursor: pointer;\n    opacity: 0.6;\n    transition: opacity 0.3s;\n}\n\n.carousel-thumbnail:hover,\n.carousel-thumbnail.active {\n    opacity: 1;\n}\n\n.carousel-thumbnail img {\n    width: 100%;\n    height: 100%;\n    object-fit: cover;\n}\n\n/* Responsive design */\n@media (max-width: 768px) {\n    .carousel-arrow {\n        padding: 10px;\n        font-size: 18px;\n    }\n\n    .carousel-caption {\n        padding: 10px;\n    }\n\n    .carousel-caption h3 {\n        font-size: 1.2em;\n    }\n\n    .thumbnail-left .carousel-thumbnails,\n    .thumbnail-right .carousel-thumbnails {\n        position: relative;\n        width: 100%;\n        flex-direction: row;\n        overflow-x: auto;\n    }\n} ";
styleInject(css_248z);

var ParallaxCarousel = function (_a) {
  var images = _a.images,
    _b = _a.interval,
    interval = _b === void 0 ? 5000 : _b,
    _c = _a.className,
    className = _c === void 0 ? "" : _c,
    onSlideChange = _a.onSlideChange,
    _d = _a.showArrows,
    showArrows = _d === void 0 ? true : _d,
    _e = _a.showDots,
    showDots = _e === void 0 ? true : _e,
    _f = _a.showThumbnails,
    showThumbnails = _f === void 0 ? false : _f,
    _g = _a.autoPlay,
    autoPlay = _g === void 0 ? true : _g,
    _h = _a.pauseOnHover,
    pauseOnHover = _h === void 0 ? true : _h,
    theme = _a.theme,
    _j = _a.effect,
    effect = _j === void 0 ? "slide" : _j,
    _k = _a.height,
    height = _k === void 0 ? "500px" : _k,
    _l = _a.thumbnailPosition,
    thumbnailPosition = _l === void 0 ? "bottom" : _l,
    _m = _a.showCaption,
    showCaption = _m === void 0 ? false : _m,
    _o = _a.infinite,
    infinite = _o === void 0 ? true : _o,
    _p = _a.keyboardControl,
    keyboardControl = _p === void 0 ? true : _p;
  var _q = useState(0),
    currentSlide = _q[0],
    setCurrentSlide = _q[1];
  var _r = useState(false),
    isPaused = _r[0],
    setIsPaused = _r[1];
  var touchStartX = useRef(0);
  var touchEndX = useRef(0);
  var containerRef = useRef(null);
  var generateCustomStyles = function () {
    if (!theme) return {};
    return {
      "--primary-color": theme.primary,
      "--secondary-color": theme.secondary,
      "--background-color": theme.background,
      "--text-color": theme.textColor
    };
  };
  var handleSlideChange = useCallback(function (newIndex) {
    var finalIndex = newIndex;
    if (!infinite) {
      finalIndex = Math.max(0, Math.min(newIndex, images.length - 1));
    } else {
      finalIndex = (newIndex + images.length) % images.length;
    }
    setCurrentSlide(finalIndex);
    onSlideChange === null || onSlideChange === void 0 ? void 0 : onSlideChange(finalIndex);
  }, [infinite, images.length, onSlideChange]);
  // Otomatik geçiş
  useEffect(function () {
    if (!autoPlay || isPaused) return;
    var timer = setInterval(function () {
      handleSlideChange(currentSlide + 1);
    }, interval);
    return function () {
      return clearInterval(timer);
    };
  }, [currentSlide, interval, autoPlay, isPaused, handleSlideChange]);
  // keyboard control
  useEffect(function () {
    if (!keyboardControl) return;
    var handleKeyDown = function (e) {
      if (e.key === "ArrowLeft") {
        handleSlideChange(currentSlide - 1);
      } else if (e.key === "ArrowRight") {
        handleSlideChange(currentSlide + 1);
      }
    };
    window.addEventListener("keydown", handleKeyDown);
    return function () {
      return window.removeEventListener("keydown", handleKeyDown);
    };
  }, [currentSlide, keyboardControl, handleSlideChange]);
  var handleTouchStart = function (e) {
    var touch = e.touches[0];
    touchStartX.current = touch.clientX;
    touchEndX.current = touch.clientX;
    containerRef.current.setAttribute("data-touching", "true");
  };
  var handleTouchMove = function (e) {
    touchEndX.current = e.touches[0].clientX;
  };
  var handleTouchEnd = function () {
    containerRef.current.removeAttribute("data-touching");
    handleSwipe();
  };
  var handleSwipe = function () {
    var swipeThreshold = 50;
    var difference = touchStartX.current - touchEndX.current;
    if (Math.abs(difference) > swipeThreshold) {
      if (difference > 0) {
        handleSlideChange(currentSlide + 1);
      } else {
        handleSlideChange(currentSlide - 1);
      }
    }
  };
  var handleMouseEnter = function () {
    if (pauseOnHover) {
      setIsPaused(true);
    }
  };
  var handleMouseLeave = function () {
    if (pauseOnHover) {
      setIsPaused(false);
    }
  };
  return React.createElement("div", {
    className: "carousel-container ".concat(className, " effect-").concat(effect, " thumbnail-").concat(thumbnailPosition),
    style: __assign(__assign({}, generateCustomStyles()), {
      height: height
    }),
    ref: containerRef,
    onTouchStart: handleTouchStart,
    onTouchMove: handleTouchMove,
    onTouchEnd: handleTouchEnd,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave,
    "data-testid": "carousel-container",
    role: "region",
    tabIndex: 0,
    "aria-label": "Image carousel"
  }, React.createElement("div", {
    className: "carousel-slides"
  }, images.map(function (image, index) {
    return React.createElement("div", {
      key: "".concat(image.url, "-").concat(index),
      className: "carousel-slide ".concat(index === currentSlide ? "active" : ""),
      "data-testid": "carousel-slide-".concat(index)
    }, React.createElement("img", {
      src: image.url,
      alt: image.alt || "Slide ".concat(index + 1),
      className: "carousel-image"
    }), showCaption && (image.title || image.description) && React.createElement("div", {
      className: "carousel-caption"
    }, image.title && React.createElement("h3", null, image.title), image.description && React.createElement("p", null, image.description)));
  })), showArrows && React.createElement(React.Fragment, null, React.createElement("button", {
    className: "carousel-arrow prev",
    onClick: function () {
      return handleSlideChange(currentSlide - 1);
    },
    disabled: !infinite && currentSlide === 0,
    "data-testid": "prev-button"
  }, "\u2039"), React.createElement("button", {
    className: "carousel-arrow next",
    onClick: function () {
      return handleSlideChange(currentSlide + 1);
    },
    disabled: !infinite && currentSlide === images.length - 1,
    "data-testid": "next-button"
  }, "\u203A")), showDots && React.createElement("div", {
    className: "carousel-controls",
    "data-testid": "carousel-controls"
  }, images.map(function (_, index) {
    return React.createElement("button", {
      key: index,
      className: "carousel-dot ".concat(index === currentSlide ? "active" : ""),
      onClick: function () {
        return handleSlideChange(index);
      },
      onKeyDown: function (e) {
        if (e.key === "Enter" || e.key === " ") {
          handleSlideChange(index);
        }
      },
      "data-testid": "carousel-dot-".concat(index),
      "aria-label": "Go to slide ".concat(index + 1)
    });
  })), showThumbnails && React.createElement("div", {
    className: "carousel-thumbnails",
    "data-testid": "carousel-thumbnails"
  }, images.map(function (image, index) {
    return React.createElement("div", {
      key: "thumb-".concat(index),
      className: "carousel-thumbnail ".concat(index === currentSlide ? "active" : ""),
      onClick: function () {
        return handleSlideChange(index);
      },
      "data-testid": "carousel-thumbnail-".concat(index)
    }, React.createElement("img", {
      src: image.url,
      alt: "Thumbnail ".concat(index + 1)
    }));
  })));
};

export { ParallaxCarousel };
//# sourceMappingURL=index.es.js.map
